#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <dos.h>
#include  <conio.h>
#include  <io.h>
#include  <alloc.h>
#include  <time.h>
#include  "pragmas.h"

#define FALSE 0
#define TRUE 1

typedef char label[31];

int  	main(int argc, char *argv[]);
void 	startup(void);
int  	readMessage(void);
void 	nodestat(void);
void 	roomstat(void);
int  	GetStr(FILE *fil, char *str, int mlen);
int  	isaddress(const char *str);
int  	sort(const void *this, const void *that);
int  	roomsort(const void *this, const void *that);
void	stripansi(char *str);

FILE    *msgdat, *nodesout, *roomsout;

char	version[11]	= "2.0";
char    inputmail[129]  = "c:\\cit\\messages\\msg.dat";
char	outputnode[129] = "nodes.lst";
char	outputroom[129] = "rooms.lst";

char	homenode[31]	= "Skaro";
char	homeadd[31]	= "skr.olm";
char	homesoft[31]	= "Citadel+/065";

static char *software[] = {
      "Autoposter",		   /* 0 */
      "Gremlin's Citadel/064.2",   /* 1 */
      "Gremlin's Citadel/064",     /* 2 */
      "Gremlin's Citadel",	   /* 3 */
      "Citadel+/066",             /* 4 */
      "Citadel+/066",              /* 5 */
      "Citadel+/065",              /* 6 */
      "Citadel+",		   /* 7 */
      "MavenCit",                  /* 8 */
      "Co-Op Citadel",             /* 9 */
      "Frog's Citadel",            /* 10 */
      "Poster",			   /* 11 */
      "C"                          /* 12 */
      };

static char *softkey[] = {
	"APost",                   /* 0 */
	"G/642",                   /* 1 */
	"G/064",                   /* 2 */
	"GCit",                    /* 3 */
	"+/66",                   /* 4 */
	"C+/66",                   /* 5 */
	"C+/65",                   /* 6 */
	"Cit+",                    /* 7 */
	"Mcit",                    /* 8 */
	"Co-Op",		   /* 9 */
	"Frog",                    /* 10 */
	"Postr",		   /* 11 */
	"????"			   /* 12 */
	};

char    path[257];
char 	soft[31];
char    messagetext[8193];
char 	name[31];
char	author[31];
char	roomname[31];
char	sig[81];

char	jaydee = 0;
char	excroom = 0;
char	debug = 0;

long	nmessages = 0;
long	messagek = 0;
int	messagebyte = 0;

time_t	starttime, endtime;

int	numnode = 0;
int	numroom = 0;

struct node {
            char nodename[31];
	    char address[31];
	    char software;
	    long messages;
	    unsigned long msgk;
            };

struct node *nodetable;

struct room {
	    char roomname[31];
	    long messages;
	    unsigned long msgk;
	    };

struct room *roomtable;

/* Main */
int main(int argc, char *argv[])
{
int i, loop;
int good = 1;
char softname[257];

     starttime = time(NULL);

     strcpy(softname, argv[0]);
     strlwr(softname);

     printf("\n"
	    "Nodelist %s (%s %s)\n"
	    "\n"
	    "By Captain James T Kirk\n"
	    "\n"
            "   Audin @ Skaro, Olympia, (360)491-9605\n"
	    "\n" , version, __DATE__, __TIME__);

     if(argc < 5 || argc > 6)
	{
	printf("With some extra code provided by Brent Bottles.\n"
	       "And still more taken from a few different versions of Citadel.\n"
	       "\n"
	       "Usage: %s msg_file output \"nodename\" address software [-A]\n"
	       "\n"
	       "       msg_file = path and filename of your msg.dat\n"
	       "         output = path and filename for output.\n"
	       "       nodename = your nodename.  MUST BE IN QUOTES if more than one word!!!\n"
	       "        address = your complete address.  (eg \"sfa.olm\")\n"
	       "       software = one of these (IN QUOTES!!!):\n", softname);
	getch();
	for(loop=0;loop<12;loop++)
	printf("                                               \"%s\"\n", software[loop]);

	printf("	     -A = (optional) including -A will not exclude Jaydee nodes.\n");
	exit(1);
	}

     if(argc > 5)
	{
	if(stricmp("-A", argv[6])==NULL)
	   {
	   jaydee = 1;
	   printf("Jaydee nodes not excluded.\n\n");
	   }
	if(stricmp("-D", argv[6])==NULL)
	   {
	   debug = 1;
	   printf("Debug mode.\n");
	   }
	}

     strcpy(inputmail, argv[1]);
     strcpy(outputnode, argv[2]);
     strcpy(homenode, argv[3]);
     strcpy(homeadd, argv[4]);
     strcpy(homesoft, argv[5]);

     printf("Input file  : %s\n", inputmail);
     printf("Node output : %s\n", outputnode);
     printf("Room output : %s\n", outputroom);
     printf("homenode    : %s\n", homenode);
     printf("homeaddress : %s\n", homeadd);
     printf("homesoftware: %s\n\n", homesoft);

     strcat(homeadd, "!b");

     startup();

     while(good)
     {
	messagebyte = 0;
	good = readMessage();
     }

     qsort(nodetable, numnode, sizeof(struct node), sort);

     fprintf(nodesout, "Nodename                    address   soft msgs % msgs  msgb  AVb/msg % msgb\n");
 fprintf(nodesout, "3a       0\n");

     if(!jaydee)
	{
	for(i=0; i<numnode; i++)
	    if(nodetable[i].nodename[0] != '\0' &&
	       nodetable[i].messages >= 8 &&
	       !(nodetable[i].messages <= 57 && nodetable[i].software == 1))
		   fprintf(nodesout, "%-25.25s (%8.8s) %5s %4ld %5.2f%% %6ld %7.2f %5.2f%%\n",
			   nodetable[i].nodename,
			   nodetable[i].address,
			   softkey[nodetable[i].software],
			   nodetable[i].messages,
			   ((float)nodetable[i].messages/nmessages*100),
			   nodetable[i].msgk,
			   ((float)nodetable[i].msgk/nodetable[i].messages),
			   ((float)nodetable[i].msgk/messagek*100));
	}
     else
	{
	for(i=0; i<numnode; i++)
	    fprintf(nodesout, "%-25.25s (%8.8s) %5s %4ld %5.2f%% %6ld %7.2f %5.2f%%\n",
		   nodetable[i].nodename,
		   nodetable[i].address,
		   softkey[nodetable[i].software],
		   nodetable[i].messages,
		   ((float)nodetable[i].messages/nmessages*100),
		   nodetable[i].msgk,
		   ((float)nodetable[i].msgk/nodetable[i].messages),
		   ((float)nodetable[i].msgk/messagek*100));
	}

   fprintf(nodesout, " \nTotal of %d nodes\n", numnode);
   fprintf(nodesout, "List generated from %ld messages totaling %ld bytes.  %ld msg.dat.\n",
	   nmessages, messagek, filelength(fileno(msgdat)));

 qsort(roomtable, numroom, sizeof(struct room), roomsort);

     fprintf(roomsout, "Roomname                       msgs % msgs  msgb  AVb/msg % msgb\n");
 fprintf(roomsout, "3a     0\n");

     for(i=0; i<numroom; i++)
	 fprintf(roomsout, "%-30.30s %4ld %5.2f%% %6ld %7.2f %5.2f%%\n",
			   roomtable[i].roomname,
			   roomtable[i].messages,
			   ((float)roomtable[i].messages/nmessages*100),
			   roomtable[i].msgk,
			   ((float)roomtable[i].msgk/roomtable[i].messages),
			   ((float)roomtable[i].msgk/messagek*100));

   fprintf(roomsout, " \nTotal of %d rooms\n", numroom);
   fprintf(roomsout, "List generated from %ld messages totaling %ld bytes.  %ld msg.dat.\n",
	   nmessages, messagek, filelength(fileno(msgdat)));

   fclose(msgdat);
   fclose(nodesout);
   fclose(roomsout);

   endtime = time(NULL);
   printf("\nElapsed time: %f", difftime(endtime, starttime));

   return(0);
}

/*
 * Read a message...
 */
int readMessage(void)
{
    char c;

    name[0] 	= 0;
    sig[0]  	= 0;
    path[0] 	= 0;
    soft[0] 	= 0;
    roomname[0] = 0;
    author[0]   = 0;

    /* find start of message */
    do
    {
	c = (unsigned char)fgetc(msgdat);
    } while (c != -1 && !feof(msgdat));

    if (feof(msgdat))
	return 0;

    fgetc(msgdat);
    fgetc(msgdat);

    do
    {
	c = (unsigned char)fgetc(msgdat);

	switch (c)
	{
	case 'A':     GetStr(msgdat, author,   30); 	break;
	case 'R':     GetStr(msgdat, roomname, 30); 	break;
	case 's':     GetStr(msgdat, soft,     30); 	break;
	case 'P':     GetStr(msgdat, path,    256);	break;
	case 'O':     GetStr(msgdat, name,     30);	break;
	case '.':     GetStr(msgdat, sig,      80);     break;
	case '_':     messagebyte += GetStr(msgdat, messagetext, 80);
		      messagetext[0] = '\0';		break;
	case 'n':     messagebyte += GetStr(msgdat, messagetext, 30);
		      messagetext[0] = '\0';		break;
	case 'N':     messagebyte += GetStr(msgdat, messagetext, 30);
		      messagetext[0] = '\0';		break;
	case '%':     messagebyte += GetStr(msgdat, messagetext, 256);
		      messagetext[0] = '\0';		break;
	case 'M':					break;

	default:
	    GetStr(msgdat, messagetext, 8192); /* discard unknown field */
	    messagetext[0]    = '\0';
	    break;
	}

    } while (c != 'M' && !feof(msgdat));

    if (feof(msgdat))
	return 0;

    messagebyte += GetStr(msgdat, messagetext, 8192);

    if(!name[0] && sig[0])
      {
      strcpy(name, homenode);
      strcpy(path, homeadd);
      strcpy(soft, homesoft);
      }

    if(name[0])
      {
      nmessages++;
      messagek += messagebyte;
      nodestat();
      roomstat();
      }

    return 1;
}

/*******************************************************/
/* nodestat() -- records node statistical information. */
/*******************************************************/
void nodestat(void)
{
int nodenum, lp, loop;
char *bang;

   bang = strchr(path, '!');

   if(bang)
	*bang = 0;

   if(isaddress(path) == NULL)
	path[0] = '\0';

   stripansi(name);

   for (lp=0, nodenum=-1; lp<numnode; lp++)
       if (stricmp(name, nodetable[lp].nodename)==0)
	   nodenum=lp;

   if (nodenum==-1)
   {
       numnode++;
       nodenum=numnode-1;

       nodetable = (void *)realloc((void *)nodetable, numnode * sizeof(struct node));

       if(debug)
	 {
	 printf("Newnode:Realloc returned: %p\n", nodetable);
	 printf("Newnode:Coreleft        : %u\n", coreleft());
	 printf("Newnode:FarCoreleft     : %lu\n", farcoreleft());
	 }

       strcpy(nodetable[nodenum].nodename, name);
       strcpy(nodetable[nodenum].address, path);

       for(loop=0; loop<12; loop++)
	   if(strstr(soft, software[loop]))
               break;

       nodetable[nodenum].software = loop;
       nodetable[nodenum].messages = 0;

       nodetable[nodenum].msgk = 0;

//       printf("new node: [%30s] (%7s), %s\n", name, path, soft);
   printf("!");
   }
   else
   {
	if(path[0] && (stricmp(nodetable[nodenum].address, path) != 0))
	  {
//	  printf(" address: [%30s] %s to %s\n",
//		 name, nodetable[nodenum].address, path);

	  strcpy(nodetable[nodenum].address, path);
	  }
	if(soft[0])
	  {
          for(loop=0; loop<12; loop++)
	      if(strstr(soft, software[loop]))
                  break;

          if(loop != nodetable[nodenum].software)
	    {
//	    printf("software: [%30s] %s to %s\n",
//	    name, softkey[nodetable[nodenum].software], softkey[loop]);

            nodetable[nodenum].software = loop;
	    }
          }

   	nodetable[nodenum].messages++;
	nodetable[nodenum].msgk += messagebyte;
   }
}

/******************************************************/
/* roomstat() -- records room statistical information */
/******************************************************/
void roomstat(void)
{
int roomnum, lp;

   stripansi(roomname);

   for (lp=0, roomnum=-1; lp<numroom; lp++)
       if (stricmp(roomname, roomtable[lp].roomname)==0)
	   roomnum=lp;

   if (roomnum==-1)
   {
       numroom++;
       roomnum=numroom-1;

       roomtable = (void *)realloc((void *)roomtable, numroom * sizeof(struct room));

       if(debug)
	 {
	 printf("Newroom:Realloc returned: %p\n", roomtable);
	 printf("Newroom:Coreleft        : %u\n", coreleft());
	 printf("Newroom:FarCoreleft     : %lu\n", farcoreleft());
	 }

       if(heapcheck() != 2)
	  {
	  printf("The heap is fucked...exiting\n");
	  printf("Coreleft   : %u %lu\n", coreleft(), coreleft());
	  printf("Farcoreleft: %lu\n", farcoreleft());
	  printf("You should probably write to Audin @ Skaro about this..\n");
	  exit(1);
	  }

       strcpy(roomtable[roomnum].roomname, roomname);

       roomtable[roomnum].messages = 0;
       roomtable[roomnum].msgk = 0;

//       printf("New Room: {%30s}\n", roomname);
   printf(".");
   }

   roomtable[roomnum].msgk += messagebyte;
   roomtable[roomnum].messages++;

}

/* -------------------------------------------------------------------- */
/*  isaddress() examines string and returns true if it looks like an    */
/*              alias (xxx.xxxx)                                        */
/* --------------------------------------------------------------------
    94Sep26 22:48:28 From Brent Bottles @ The Anticlimactic Teleservice, 
Seattle In WAN Admin>
"St. Dism" continues to be less than valid as an address.               
*/ 

int isaddress(const char *str)
    {
    int len;
    int dotpos;
    int FoundDot = FALSE;
    int i;
 
    len = strlen(str);
 
    // Don't be fooled by "St. Dism"
    if (strchr(str, ' ') != NULL)
        {
        return (FALSE);
        }
 
    for (i = 0; i < len; i++)
        {
        if (str[i] == '.')
            {
            // we can only have one dot.
            if (FoundDot)
                {
                return (FALSE);
                }
 
            dotpos = i;
            FoundDot = TRUE;
            }
        }
 
    if  (   // 1, 2, or 3 chars, no dots
            ((len > 1) && (len < 4) && !FoundDot)
 
            ||
 
            // 4, 5, 6, 7, or 8 chars, there is a dot, and it is at char
            // pos 2, 3, or 4, and not too close to the end.
            (   (len > 3) && (len < 9) && FoundDot && (dotpos > 1) &&
                (dotpos < 4) && ((len - dotpos) < 6)
            )
        )
        {
        return (TRUE);
        }
 
    return (FALSE);
    } 

/*  
 (That 'Don't be fooled by "St. Dism"' comment is a little out-of-date: 
checking for the position of the dot was added later, and "St. Dism" would fail
that.  However, this check is still good to do, as "poo.po o" would pass the 
dotpos test, but fail the strchr() test.) 

------
i'm cute
*/

/**********************************/
/* sort thingy.                   */
/**********************************/
int sort(const void *this1, const void *that1)
{
  const struct node *this = this1;
  const struct node *that = that1;
  long valret=0;
/*
  if(((float)this->msgk/messagek) > ((float)that->msgk/messagek))
	valret = 0;
  else
	valret = 1;
*/
  if(stricmp(this->nodename, that->nodename) < 0)
	valret = 0;
  else
	valret = 1;

  return(valret > 0L ? 1 : -1);
}

/**********************************/
/* Room sort thingy.              */
/**********************************/
int roomsort(const void *this1, const void *that1)
{
  const struct room *this = this1;
  const struct room *that = that1;
  long valret=0;

  if(((float)this->msgk/messagek) > ((float)that->msgk/messagek))
	valret = 0;
  else
	valret = 1;

  return(valret > 0L ? 1 : -1);
}

/* -------------------------------------------------------------------- */
/*  GetStr()        gets a null-terminated string from a file           */
/* -------------------------------------------------------------------- */
int GetStr(FILE *fil, char *str, int mlen)
{

    int   l = 0;
    unsigned char ch = 1;

    while(!feof(fil) && ch)
    {
	ch=(unsigned char)fgetc(fil);
	if ((ch != 0xFF && ch != '\r') && l < mlen)
	{
	    str[l]=ch;
	    l++;
	}
    }
    str[l]='\0';

    return(l);
}

/* changes string being sent, does not return a pointer like deansi */
void stripansi(char *str)
{
    int i=0;

    char *pc;
    pc = str;

    while (*pc)  
    {
	if (*pc == 1 || *pc == 10)   pc += 2;   /* Zap Ctrl-A plus following Char */
        else
        {
            str[i] = *pc;
            i++;
            pc++;
        }
    }
    str[i] = 0;
}    

/* -------------------------------------------------------------------- */
/*  startup...  opens all files.                                        */
/* -------------------------------------------------------------------- */
void startup(void)
{
   nodetable = (void *)calloc(1, sizeof(struct node));

   roomtable = (void *)calloc(1, sizeof(struct room));

   if((msgdat = fopen(inputmail, "rb")) == NULL)
     {
	 printf(" I can't seem to find \"%s\".\n", inputmail);
	 exit(1);
     }

   setvbuf(msgdat, NULL, _IOFBF, 4096);

   if((nodesout = fopen(outputnode, "rb")) != NULL)
     {
     printf(" I need to be able to write to \"%s\".\n"
	    " However, it seems to already exist.  You should probably delete it.\n", outputnode);
     exit(1);
     }

   if((nodesout = fopen(outputnode, "wt")) == NULL)
     {
	 printf(" I can't seem to open \"%s\" for output.\n", outputnode);
	 exit(1);
     }

   fprintf(nodesout, "\n53List of current active citnet nodes and addresses.0\n"
                    "\n"
		    "This list is created automaticly by scanning the %s message\n"
		    "base for node names.  Thus it is possable for new or quiet nodes to be missed.\n"
		    "\n", homenode);
   if(!jaydee)
   fprintf(nodesout,"Only nodes with more than 8 messages are listed.\n"
		    "Also, nodes running /064 must post more than 57 messages to be included.\n"
		    "\n");

   fprintf(nodesout, "%% msgs is the percentage of total messages that come from the node.\n"
		    "Msgb is the total ammount of message text to come from the node, in bytes.\n"
		    "AVb/msg is the average message size from the node, in bytes.\n"
		    "%% msgb is the percentage of total message text that comes from the node.\n"
		    "\n");

   if((roomsout = fopen(outputroom, "rb")) != NULL)
     {
     printf(" I need to be able to write to \"%s\".\n"
	    " However, it seems to already exist.  You should probably delete it.\n", outputroom);
     exit(1);
     }

   if((roomsout = fopen(outputroom, "wt")) == NULL)
     {
	 printf(" I can't seem to open \"%s\" for output.\n", outputroom);
	 exit(1);
     }

   fprintf(roomsout, "53List of currently active Citnet rooms.\n"
		     "\n"
		     "%% msgs is the percentage of total messages that are in that room.\n"
		     "Msgb is the total ammount of message text in the room, in bytes.\n"
		     "AVb/msg is the room's average message size, also in bytes.\n"
		     "%% msgb is the percentage of total network message text in that room.\n"
		     "\n");


}
